#ifndef PORT_H
#define PORT_H

#include <Arduino.h>
#include <Servo.h>
#include "ARPStepper.h"
#include <vector>

class Port
{
public :
    
Port(char name);

void setNbDmxChannels(uint16_t nbChannels);//should auto adjust, except for pixel Led
uint16_t getNbDmxChannels()const;
uint16_t getMode()const;
String writeMode()const;

//record prototypes (overloaded)
void record(String name,uint8_t val )const;
void record(String name,uint16_t val )const;
void record(String name,uint32_t val )const;
void record(String name,bool val )const;
void record(String name,float val )const ;
// load methods (overloaded) il faut envoyer la valeur par défaut en argument.
uint8_t load(String name,uint8_t val)const;
uint16_t load(String name,uint16_t val)const;
uint32_t load(String name,uint32_t val)const;
bool load(String name,bool val)const;
float load(String name,float val)const ;

void init();
void PWM_setup();
void on_off_setup();
void servo_setup();
void stepper_setup();
void CCmotor_setup();
void custom_setup();

//les méthodes action
void action(const std::vector<uint8_t> & DMXslice);
void PWM_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin);
void on_off_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin)const;
void servo_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin)const;
void stepper_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin)const;
void CCmotor_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin)const;
void custom_action(const std::vector<uint8_t> & DMXslice,uint8_t startPin)const;

void runAtEachLoop();

void debug();


protected:

char m_port_name;// ('A' ou 'B')
//uint16_t m_offset;//ajout Jacques 
uint16_t m_nbDmxChannels;

uint8_t m_mode;

bool m_dmxRes;
//PWM
uint8_t m_pwmRes;
uint8_t m_pwmCurve;
uint32_t m_pwmFreq;//calculé dans le setup
uint16_t m_actual_level[8];
uint16_t m_target_level[8];
//on/off
uint8_t m_trigger;//m_bascule renommé en m_trigger
bool m_inverted;
////servo
Servo *m_servo=NULL;//Déclaration d'un pointeur sur un objet de type Servo
uint16_t m_servoAngle;
bool m_servoDetach;
////stepper
ArpStepper *m_stepper=NULL;//Déclaration d'un pointeur sur un objet de type ArpStepper
bool m_stp_active[4];
//uint16_t m_stepPerRevolution[4];
//uint16_t m_rpmMin[4];
//uint16_t m_rpmMax[4];
//uint16_t m_nbRevolution[4];
bool m_action[4];
bool m_stp_dmxRes[4];//true : _16bits, false : _8bits
////CCmotor
//bool m_CC_active[4];
bool m_CC_inverted[4];
uint8_t m_cc_threshold[4];
};

#endif 